package be.cylab.java.wowa.training;

import java.util.logging.Logger;

public class TrainerParameters {
    public static final int SELECTION_METHOD_RWS = 374;
    public static final int SELECTION_METHOD_TOS = 942;

    public static final int INITIAL_POPULATION_GENERATION_RANDOM = 461;
    public static final int INITIAL_POPULATION_GENERATION_QUASI_RANDOM = 175;


    private Logger logger;
    private String learningCurveFile;
    private int populationSize;
    private int crossoverRate;
    private int mutationRate;
    private int selectionMethod;
    private int populationInitilizationMethod;

    private int maxGenerationNumber;
    private float triggerDistance;

    public TrainerParameters(
            //Logger logger,
            int populationSize,
            int crossoverRate,
            int mutationRate,
            int selectionMethod,
            int maxGenerationNumber,
            int populationInitializationMethod,
            String learningCuveFile

    ) {
        //this.setLogger(logger);
        this.setPopulationSize(populationSize);
        this.setCrossoverRate(crossoverRate);
        this.setMutationRate(mutationRate);
        this.setSelectionMethod(selectionMethod);
        this.setSelectionMethod(selectionMethod);
        this.setMaxGenerationNumber(maxGenerationNumber);
        this.setPopulationInitilizationMethod(populationInitializationMethod);
        this.setLearningCurveFile(learningCuveFile);

    }

    public int getNumberParents() {
        int nbreParents = Math.round(this.getPopulationSize() * (1 - this.getCrossoverRate() / 100));
        if (nbreParents % 2 == 1) {
            nbreParents++;
        }
        return nbreParents;
    }

    public Logger getLogger() {
        return logger;
    }

    public void setLogger(Logger logger) {
        this.logger = logger;
    }

    public String getLearningCurveFile() {
        return learningCurveFile;
    }

    public void setLearningCurveFile(String learningCurveFile) {
        this.learningCurveFile = learningCurveFile;
    }

    public int getPopulationSize() {
        return populationSize;
    }

    public void setPopulationSize(int populationSize) throws ArithmeticException {
        if (populationSize < 2) {
            throw new ArithmeticException("Population must be higher than 2");
        }
        this.populationSize = populationSize;
    }

    public int getCrossoverRate() {
        return crossoverRate;
    }

    public void setCrossoverRate(int crossoverRate) {
        this.crossoverRate = crossoverRate;
    }

    public int getMutationRate() {
        return mutationRate;
    }

    public void setMutationRate(int mutationRate) {
        this.mutationRate = mutationRate;
    }

    public int getSelectionMethod() {
        return selectionMethod;
    }

    public void setSelectionMethod(int selectionMethod) {
        this.selectionMethod = selectionMethod;
    }

    public int getPopulationInitilizationMethod() {
        return populationInitilizationMethod;
    }

    public void setPopulationInitilizationMethod(int populationInitilizationMethod) {
        this.populationInitilizationMethod = populationInitilizationMethod;
    }

    public int getMaxGenerationNumber() {
        return maxGenerationNumber;
    }

    public void setMaxGenerationNumber(int maxGenerationNumber) {
        this.maxGenerationNumber = maxGenerationNumber;
    }

    public float getTriggerDistance() {
        return triggerDistance;
    }

    public void setTriggerDistance(float triggerDistance) {
        this.triggerDistance = triggerDistance;
    }
}
